c      RGB VALUES FOR DIFFERENT VISIBLE WAVELENGTHS
c        
c      John Kielkopf
c
c      Create a color ppm image of the visible spectrum
c      Test rgb generator in subroutine wl2rgb


       IMPLICIT REAL*8 (a-h,o-z)
       DIMENSION ICV(1000,100,3)

c
c      IMAGE INFO - WIDTH, HEIGHT, DEPTH, GAMMA
c
       M=800
       N=50
       MX=255
       GAM=0.8
c
c      FIND COLOR VALUE, ICV, OF EACH PIXEL 
c
       DO I=1,M
        AI=I-1
        AM=M-1
        WL=380.D0 + 400.D0*AI/AM
        CALL WL2RGB(WL,R,G,B)
        DO J=1,N
         RMAX=1.D0
         ICV(I,J,1)=INT(REAL(MX)*(R/RMAX)**GAM)
         ICV(I,J,2)=INT(REAL(MX)*(G/RMAX)**GAM)
         ICV(I,J,3)=INT(REAL(MX)*(B/RMAX)**GAM)
        ENDDO
       ENDDO
c
c*****************************************************************************
c
c      WRITE OUTPUT TO PPM FILE
c
c      Output color values are normalized to color depth, MX.
c
       OPEN(UNIT=20,FILE='spectrum.ppm',STATUS='UNKNOWN')
1      FORMAT (A10)
       WRITE(20,1) 'P3        '
       WRITE(20,1) '# spectrum.ppm'
       WRITE(20,*) M,N
       WRITE(20,*) MX
       DO J=1,N
        DO I=1,M
         WRITE(20,*) ICV(I,J,1),ICV(I,J,2),ICV(I,J,3)
        ENDDO
       ENDDO
       STOP
       END 
c
c ****************************************************************************
c
c      RGB COLORS FROM WAVELENGTH IN NM
c
c
c
       SUBROUTINE WL2RGB(WL,R,G,B)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)

       R=0.D0
       G=0.D0
       B=0.D0
       IF((WL.GE.(380.D0)).AND.(WL.LE.(780.D0))) THEN
        RHI=1.0D0/(1.D0+DEXP(((540.D0-WL)/15.D0)))
        RHI=RHI/(1.D0+DEXP(((WL-670.D0)/20.D0)))
        RLO=0.4D0/(1.D0+DEXP(((WL-440.D0)/30.D0)))
        RLO=RLO/(1.D0+DEXP(((390.D0-WL)/20.D0)))
        R=RHI+RLO
        G=1.0D0/(1.D0+DEXP(((WL-600.D0)/20.D0)))
        G=G/(1.D0+DEXP(((480.D0-WL)/15.D0)))
        G=G*1.02D0
        B=1.0D0/(1.D0+DEXP(((WL-500.D0)/15.D0)))
        B=B/(1.D0+DEXP(((400.D0-WL)/20.D0)))
        B=B*1.0D0
       ENDIF
       RETURN
       END

c ************************************************************************
